function q = ecupi(p,param)
   w1 = p(1);
   w2 = p(2);
   mgd = param(1); mfd = param(2); a = param(3);
   b=param(4); num1=param(5:5+a-1);den1=param(5+a:5+b+a-1);
   q = 0;
   [mag1,fase1] = bode(num1',den1',w1);
   [mag2,fase2] = bode(num1',den1',w2);
   if (fase1>0.), fase1=fase1-360.; end
   if (fase2>0.), fase2=fase2-360.; end
   pha1 = (-180+mfd-fase1)/57.3;
   pha2 = (-180-fase2)/57.3;
   a1 = cos(pha1)*mag2*mgd-cos(pha2)*mag1;
   aux1=w1/cos(pha1);
   aux2=w2/cos(pha2);
   a2 = (aux1*aux1-w1*w1)-(aux2*aux2-w2*w2);
   a3 = (w1<0);
   a4 = (w2<w1);
   a5 = (pha1>0);
   a6 = (pha2>0);
   a7 = (pha1<(-pi/2));
   a8 = (pha2<(-pi/2));
   q = a1*a1+a2*a2+100*(a3*a3+a4*a4+a5*a5+a6*a6+a7*a7+a8*a8);
