function q = ecupid(p,param)
   w1 = p(1);
   w2 = p(2);
   mgd = param(1); mfd = param(2); alf = param(3);aa = param(4);
   bb=param(5); num1=param(6:6+aa-1);den1=param(6+aa:6+bb+aa-1);
   q = 0;
   [mag1,fase1] = bode(num1',den1',w1);
   [mag2,fase2] = bode(num1',den1',w2);
   if (fase1>0), fase1=fase1-360;end
   if (fase2>0), fase2=fase2-360;end
   pha1 = (-180+mfd-fase1)/57.3;
   pha2 = (-180-fase2)/57.3;
   a1 = (cos(pha1)/mag1)-(cos(pha2)/(mgd*mag2));
   aux1 = (tan(pha1)+sqrt(4*alf+tan(pha1)*tan(pha1)))/(2*alf*w1);
   aux2 = (tan(pha2)+sqrt(4*alf+tan(pha2)*tan(pha2)))/(2*alf*w2);
   a2 = aux1-aux2;
   a3 = (w1<0);
   a4 = (w2<w1);
   a5 = (abs(pha1)>(pi/2.01));
   a6 = (abs(pha2)>(pi/2.01));
   q = a1*a1+a2*a2+100*(a3*a3+a4*a4+a5*a5+a6*a6);
