function q = ecupid1(p,param)
   w1 = p(1);
   w2 = p(2);
   gan = p(3);
   ti = p(4);
   mgd = param(1); mfd = param(2); alf = param(3);aa = param(4);
   bb=param(5); num1=param(6:6+aa-1);den1=param(6+aa:6+bb+aa-1);
   q = 0;
   num1=num1';
   den1=den1';
   [mag1,fase1] = bode(num1,den1,w1);
   [mag2,fase2] = bode(num1,den1,w2);
   if (fase1>0.), fase1=fase1-360.; end
   if (fase2>0.), fase2=fase2-360.; end
   pha1 = (-180+mfd-fase1)/57.3;
   pha2 = (-180-fase2)/57.3;
   aux11 = (w1*alf*ti)^2;
   aux22 = (w2*alf*ti)^2;
   aux1 = 1 + 0.01*aux11;
   aux2 = 1 + 0.01*aux22;
   a1 = (mgd*mag2*gan)-cos(pha2)/(1+0.1*aux22/aux2);
   a2 = (mag1*gan)-cos(pha1)/(1+0.1*aux11/aux1);
   a3 = tan(pha2)-((w2*alf*ti/aux2)-(1/w2*ti))/(1+(0.1*aux22/aux2));
   a4 = tan(pha1)-((w1*alf*ti/aux1)-(1/w1*ti))/(1+(0.1*aux11/aux1));
   a5 = (w1<0);
   a6 = (w2<w1);
   a7 = (abs(pha1)>(pi/2.01));
   a8 = (abs(pha2)>(pi/2.01));
   q = a1*a1+a2*a2+a3*a3+a4*a4+100*(a5*a5+a6*a6+a7*a7+a8*a8);

