%  Respx   calcula la respuesta temporal de un sistema con
% polos en la posicion marcada por el raton. El orden del
% sistema se va incrementando con cada punto marcado hasta
% que se pulsa el boton derecho.

figure(1)
clf
figure(2)
clf
whitebg('black')
t=0:0.1:10;
l1=-3:.1:1;
l2=-10:0.1:10;
tn=[0 10 -0.5 2];
vr=[-3 1 -10 10];
figure(1)
   axis(vr)
   hold on
   grid on
   title('boton derecho borra, salir=click <-3')
   plot(l1,zeros(size(l1)),'y')
   plot(zeros(size(l2)),l2,'y')
   plot(l1,-3*l1,'.g')
dsig=1;
nua=[1];
dena=[1];

while dsig > -3.1,
   figure(1)
   axis(vr)
   hold on
   [dsig,dome,button]=ginput(1);
   plot(dsig,dome,'+r')
    if abs(dome) <= 0.1
      deno1=[1 -dsig];
      nu1=[-dsig];
    else
      deno1=[1 -2*dsig dsig*dsig+dome*dome];
      nu1=[dsig*dsig+dome*dome];
    end
    if ((button == 1) & (dsig >= -3.1)),
      deno=conv(deno1,dena);
      nu=conv(nu1,nua);
      dena=deno;
      nua=nu;
      nm=[zeros(1,length(deno)-length(nu)) nu];
      r=step(nm,deno,t);
   end;
   hold off
   figure(2)
   axis(tn);
   hold on
   plot(t,r)
   title('respuesta en lazo abierto');
    if (button >= 2),
      clf
      figure(1)
      clf
      axis(vr)
      hold on
      grid on
      title('boton derecho borra, salir=click <-3')
      plot(l1,zeros(size(l1)),'y')
      plot(zeros(size(l2)),l2,'y')
      plot(l1,-3*l1,'.g')
      nua=[1];
      dena=[1];
    end;
end;
clf;

